import { Schema } from "./Schema";
import { SchemaType } from "./SchemaType";
import { AttributeMap, AttributeValue } from "aws-sdk/clients/dynamodb";
/**
 * Converts a JavaScript object into a DynamoDB Item.
 *
 * @param schema Metadata explaining how the provided input is to be marshalled
 * @param input JavaScript object to convert
 */
export declare function marshallItem(schema: Schema, input: {
    [key: string]: any;
}): AttributeMap;
/**
 * Converts a value into a DynamoDB AttributeValue.
 *
 * @param schemaType    Metadata outlining how the value is to be understood and
 *                      converted
 * @param input         Value to convert
 */
export declare function marshallValue(schemaType: SchemaType, input: any): AttributeValue | undefined;
