"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var isKey_1 = require("./isKey");
var marshallItem_1 = require("./marshallItem");
function marshallKey(schema, input, indexName) {
    var marshalled = {};
    try {
        for (var _a = tslib_1.__values(Object.keys(schema)), _b = _a.next(); !_b.done; _b = _a.next()) {
            var propertyKey = _b.value;
            var fieldSchema = schema[propertyKey];
            if (isKey_1.isKey(fieldSchema, indexName)) {
                var _c = fieldSchema.attributeName, attributeName = _c === void 0 ? propertyKey : _c;
                var value = marshallItem_1.marshallValue(fieldSchema, input[propertyKey]);
                if (value) {
                    marshalled[attributeName] = value;
                }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return marshalled;
    var e_1, _d;
}
exports.marshallKey = marshallKey;
//# sourceMappingURL=marshallKey.js.map